Attribute VB_Name = "modIdentification"
Option Explicit

Private Const APP_HITPOINTS_DELIMITER As String = ":"

Public app_hitpoints_minimum As Integer
Public app_hitpoints_maximum As Integer

Public scan_besthitcount As Integer
Public scan_besthitname As String

Public scan_response As String

Public scan_time As String
Public scan_date As String
Public scan_targethost As String
Public scan_targetport As Long
Public scan_targetsecure As Integer

Public fingerprint_full As String
Public fingerprint_will As String
Public fingerprint_wont As String
Public fingerprint_do As String
Public fingerprint_dont As String

Public Function GetFingerprint(ByRef sResponse As String) As String
    Dim i As Integer
    Dim iLength As Integer
    Dim iSymbol As Integer
    Dim iLookahead As Integer
    Dim iLookback As Integer
    Dim sFingerprint As String
        
    Dim lList As ListItem
    Dim iId As Integer
    Dim sType As String
        
    iLength = Len(sResponse)
    
    iId = 0
    
    If (iLength) Then
        If (Asc(Mid$(sResponse, 1, 1)) = 255) Then
            For i = 1 To iLength
                iSymbol = Asc(Mid$(sResponse, i, 1))
                fingerprint_full = fingerprint_full & iSymbol & "-"
                
                If (i < iLength) Then
                    iLookahead = Asc(Mid$(sResponse, i + 1, 1))
                End If
                
                If (iSymbol = 13 Or iSymbol = 10) Then
                    Exit For
                Else
                    If (iSymbol <> 255) Then
                        sFingerprint = sFingerprint & iSymbol

                        If (iLookback = 251) Then
                            fingerprint_will = fingerprint_will & iSymbol & ";"
                            sType = "will"
                        ElseIf (iLookback = 252) Then
                            fingerprint_wont = fingerprint_wont & iSymbol & ";"
                            sType = "wont"
                        ElseIf (iLookback = 253) Then
                            fingerprint_do = fingerprint_do & iSymbol & ";"
                            sType = "do"
                        ElseIf (iLookback = 254) Then
                            fingerprint_dont = fingerprint_dont & iSymbol & ";"
                            sType = "dont"
                        Else
                            sType = vbNullString
                        End If
    
                        If (sType <> vbNullString Or iLookahead = 255) Then
                            sFingerprint = sFingerprint & "-"
                        
                            iId = iId + 1
                            Set lList = frmMain.lsvNegotiation.ListItems.Add(, , iId)
                                lList.SubItems(1) = sType
                                lList.SubItems(2) = iSymbol
                                lList.SubItems(3) = GetOptionDescription(iSymbol)
                                lList.SubItems(4) = GetOptionSource(iSymbol)
                        ElseIf (iLookahead <> 13 And iLookahead <> 10 And i < iLength) Then
                            sFingerprint = sFingerprint & ":"
                        End If
                    End If
                End If
                                
                iLookback = iSymbol
            Next i
        End If
    End If
    
    GetFingerprint = sFingerprint
End Function

Public Function GetOptionDescription(ByRef iCode As Integer) As String
    If (iCode = 0) Then
        GetOptionDescription = "Binary Transmission"
    ElseIf (iCode = 1) Then
        GetOptionDescription = "Echo"
    ElseIf (iCode = 2) Then
        GetOptionDescription = "Reconnection"
    ElseIf (iCode = 3) Then
        GetOptionDescription = "Suppress Go Ahead"
    ElseIf (iCode = 4) Then
        GetOptionDescription = "Approx Message Size Negotiation"
    ElseIf (iCode = 5) Then
        GetOptionDescription = "Status"
    ElseIf (iCode = 6) Then
        GetOptionDescription = "Timing Remark"
    ElseIf (iCode = 7) Then
        GetOptionDescription = "Remote Controlled Trans and Echo"
    ElseIf (iCode = 8) Then
        GetOptionDescription = "Output Line Width"
    ElseIf (iCode = 9) Then
        GetOptionDescription = "Output Page Size"
    ElseIf (iCode = 10) Then
        GetOptionDescription = "Output Carriage-Return Disposition"
    ElseIf (iCode = 11) Then
        GetOptionDescription = "Output Horizontal Tab Stops"
    ElseIf (iCode = 12) Then
        GetOptionDescription = "Output Horizontal Tab Disposition"
    ElseIf (iCode = 13) Then
        GetOptionDescription = "Output Formfeed Disposition"
    ElseIf (iCode = 14) Then
        GetOptionDescription = "Output Vertical Tabstops"
    ElseIf (iCode = 15) Then
        GetOptionDescription = "Output Vertical Tab Disposition"
    ElseIf (iCode = 16) Then
        GetOptionDescription = "Output Linefeed Disposition"
    ElseIf (iCode = 17) Then
        GetOptionDescription = "Extended ASCII"
    ElseIf (iCode = 18) Then
        GetOptionDescription = "Logout"
    ElseIf (iCode = 19) Then
        GetOptionDescription = "Byte Macro"
    ElseIf (iCode = 20) Then
        GetOptionDescription = "Data Entry Terminal"
    ElseIf (iCode = 21) Then
        GetOptionDescription = "SUPDUP"
    ElseIf (iCode = 22) Then
        GetOptionDescription = "SUPDUP Output"
    ElseIf (iCode = 23) Then
        GetOptionDescription = "Send Location"
    ElseIf (iCode = 24) Then
        GetOptionDescription = "Terminal Type"
    ElseIf (iCode = 25) Then
        GetOptionDescription = "End of Record"
    ElseIf (iCode = 26) Then
        GetOptionDescription = "TACACS User Identification"
    ElseIf (iCode = 27) Then
        GetOptionDescription = "Output Marking"
    ElseIf (iCode = 28) Then
        GetOptionDescription = "Terminal Location Number"
    ElseIf (iCode = 29) Then
        GetOptionDescription = "Telnet 3270 Regime"
    ElseIf (iCode = 30) Then
        GetOptionDescription = "X.3 PAD"
    ElseIf (iCode = 31) Then
        GetOptionDescription = "Negotiate About Window Size"
    ElseIf (iCode = 32) Then
        GetOptionDescription = "Terminal Speed"
    ElseIf (iCode = 33) Then
        GetOptionDescription = "Remote Flow Control"
    ElseIf (iCode = 34) Then
        GetOptionDescription = "Linemode"
    ElseIf (iCode = 35) Then
        GetOptionDescription = "X Display Location"
    ElseIf (iCode = 36) Then
        GetOptionDescription = "Environment Option"
    ElseIf (iCode = 37) Then
        GetOptionDescription = "Authentication Option"
    ElseIf (iCode = 38) Then
        GetOptionDescription = "Encryption Option"
    ElseIf (iCode = 39) Then
        GetOptionDescription = "New Environment Option"
    ElseIf (iCode = 40) Then
        GetOptionDescription = "TN3270E"
    ElseIf (iCode = 41) Then
        GetOptionDescription = "XAUTH"
    ElseIf (iCode = 42) Then
        GetOptionDescription = "CHARSET"
    ElseIf (iCode = 43) Then
        GetOptionDescription = "Telnet Remote Serial Port (RSP)"
    ElseIf (iCode = 44) Then
        GetOptionDescription = "Com Port Control Option"
    ElseIf (iCode = 45) Then
        GetOptionDescription = "Telnet Suppress Local Echo"
    ElseIf (iCode = 46) Then
        GetOptionDescription = "Telnet Start TLS"
    ElseIf (iCode = 47) Then
        GetOptionDescription = "KERMIT"
    ElseIf (iCode = 48) Then
        GetOptionDescription = "SEND-URL"
    ElseIf (iCode = 49) Then
        GetOptionDescription = "FORWARD X"
    ElseIf (iCode > 49 And iCode < 138) Then
        GetOptionDescription = "Unassigned"
    ElseIf (iCode = 138) Then
        GetOptionDescription = "TELOPT PRAGMA LOGON"
    ElseIf (iCode = 139) Then
        GetOptionDescription = "TELOPT SSPI LOGON"
    ElseIf (iCode = 140) Then
        GetOptionDescription = "TELOPT PRAGMA HEARTBEAT"
    ElseIf (iCode > 140 And iCode < 255) Then
        GetOptionDescription = "Unknown / Unassigned"
    ElseIf (iCode = 255) Then
        GetOptionDescription = "Extended-Options-List"
    Else
        GetOptionDescription = "Unknown / Overflow"
    End If
End Function

Public Function GetOptionSource(ByRef iCode As Integer) As String
    If (iCode = 0) Then
        GetOptionSource = "RFC856"
    ElseIf (iCode = 1) Then
        GetOptionSource = "RFC857"
    ElseIf (iCode = 2) Then
        GetOptionSource = "NIC50005"
    ElseIf (iCode = 3) Then
        GetOptionSource = "RFC858"
    ElseIf (iCode = 4) Then
        GetOptionSource = "ETHERNET"
    ElseIf (iCode = 5) Then
        GetOptionSource = "RFC859"
    ElseIf (iCode = 6) Then
        GetOptionSource = "RFC860"
    ElseIf (iCode = 7) Then
        GetOptionSource = "RFC726"
    ElseIf (iCode = 8) Then
        GetOptionSource = "NIC50005"
    ElseIf (iCode = 9) Then
        GetOptionSource = "NIC50005"
    ElseIf (iCode = 10) Then
        GetOptionSource = "RFC652"
    ElseIf (iCode = 11) Then
        GetOptionSource = "RFC653"
    ElseIf (iCode = 12) Then
        GetOptionSource = "RFC654"
    ElseIf (iCode = 13) Then
        GetOptionSource = "RFC655"
    ElseIf (iCode = 14) Then
        GetOptionSource = "RFC656"
    ElseIf (iCode = 15) Then
        GetOptionSource = "RFC657"
    ElseIf (iCode = 16) Then
        GetOptionSource = "RFC658"
    ElseIf (iCode = 17) Then
        GetOptionSource = "RFC698"
    ElseIf (iCode = 18) Then
        GetOptionSource = "RFC727"
    ElseIf (iCode = 19) Then
        GetOptionSource = "RFC735"
    ElseIf (iCode = 20) Then
        GetOptionSource = "RFC1043"
    ElseIf (iCode = 21) Then
        GetOptionSource = "RFC736"
    ElseIf (iCode = 22) Then
        GetOptionSource = "RFC749"
    ElseIf (iCode = 23) Then
        GetOptionSource = "RFC779"
    ElseIf (iCode = 24) Then
        GetOptionSource = "RFC1091"
    ElseIf (iCode = 25) Then
        GetOptionSource = "RFC885"
    ElseIf (iCode = 26) Then
        GetOptionSource = "RFC927"
    ElseIf (iCode = 27) Then
        GetOptionSource = "RFC933"
    ElseIf (iCode = 28) Then
        GetOptionSource = "RFC946"
    ElseIf (iCode = 29) Then
        GetOptionSource = "RFC1041"
    ElseIf (iCode = 30) Then
        GetOptionSource = "RFC1053"
    ElseIf (iCode = 31) Then
        GetOptionSource = "RFC1073"
    ElseIf (iCode = 32) Then
        GetOptionSource = "RFC1079"
    ElseIf (iCode = 33) Then
        GetOptionSource = "RFC1372"
    ElseIf (iCode = 34) Then
        GetOptionSource = "RFC1184"
    ElseIf (iCode = 35) Then
        GetOptionSource = "RFC1096"
    ElseIf (iCode = 36) Then
        GetOptionSource = "RFC1408"
    ElseIf (iCode = 37) Then
        GetOptionSource = "RFC2941"
    ElseIf (iCode = 38) Then
        GetOptionSource = "RFC2946"
    ElseIf (iCode = 39) Then
        GetOptionSource = "RFC1572"
    ElseIf (iCode = 40) Then
        GetOptionSource = "RFC1647"
    ElseIf (iCode = 41) Then
        GetOptionSource = "Earhart"
    ElseIf (iCode = 42) Then
        GetOptionSource = "RFC2066"
    ElseIf (iCode = 43) Then
        GetOptionSource = "Barnes"
    ElseIf (iCode = 44) Then
        GetOptionSource = "RFC2217"
    ElseIf (iCode = 45) Then
        GetOptionSource = "Atmar"
    ElseIf (iCode = 46) Then
        GetOptionSource = "Boe"
    ElseIf (iCode = 47) Then
        GetOptionSource = "RFC2840"
    ElseIf (iCode = 48) Then
        GetOptionSource = "Croft"
    ElseIf (iCode = 49) Then
        GetOptionSource = "Altman"
    ElseIf (iCode > 49 And iCode < 138) Then
        GetOptionSource = "IANA"
    ElseIf (iCode = 138) Then
        GetOptionSource = "McGregory"
    ElseIf (iCode = 139) Then
        GetOptionSource = "McGregory"
    ElseIf (iCode = 140) Then
        GetOptionSource = "McGregory"
    ElseIf (iCode > 140 And iCode < 255) Then
        GetOptionSource = "IANA"
    ElseIf (iCode = 255) Then
        GetOptionSource = "RFC861"
    Else
        GetOptionSource = "IANA"
    End If
End Function


Public Function FindMatchInDatabase(ByRef sDatabase As String, ByRef sFingerprint As String) As String
    Dim sDatabaseContent() As String
    Dim sFingerprintInDatabase As String
    Dim iDatabaseEntries As Integer
    Dim iDelimiterPosition As Integer
    Dim i As Integer
    Dim cMatches As Concat
        
    Dim sFingerprintElements() As String
    Dim iFingerprintElementsCount As Integer
    Dim j As Integer
    
    sFingerprintElements = Split(sFingerprint, ";", , vbBinaryCompare)
    iFingerprintElementsCount = UBound(sFingerprintElements)
    
    Set cMatches = New Concat
    
    sDatabaseContent = Split(ReadFile(sDatabase), vbCrLf, , vbBinaryCompare)
    iDatabaseEntries = UBound(sDatabaseContent)
    
    For j = 0 To iFingerprintElementsCount
        
        For i = 0 To iDatabaseEntries
            If LenB(sFingerprintElements(j)) Then
                If LenB(sDatabaseContent(i)) Then
                    iDelimiterPosition = InStr(1, sDatabaseContent(i), ";", vbBinaryCompare)
                    sFingerprintInDatabase = Mid$(sDatabaseContent(i), iDelimiterPosition + 1, Len(sDatabaseContent(i)) - iDelimiterPosition)
                    
                    If (sFingerprintInDatabase = sFingerprintElements(j)) Then
                        cMatches.Concat Mid$(sDatabaseContent(i), 1, InStr(1, sDatabaseContent(i), ";", vbBinaryCompare) - 1)
                        
                        If (i < iDatabaseEntries) Then
                            cMatches.Concat ";"
                        End If
                    End If
                End If
            End If
        Next i
    
    Next j
    
    FindMatchInDatabase = cMatches.Value
End Function

Public Function GenerateMatchStatistics(ByRef sMatchList As String) As String
    Dim sMatches() As String
    Dim iMatchCount As Integer
    Dim i As Integer
    Dim j As Integer
    Dim bDuplicate As Boolean
    Dim cMatchStatistic As Concat
    
    Set cMatchStatistic = New Concat
    
    sMatches = Split(sMatchList, ";", , vbBinaryCompare)
    Call RemoveDuplicatesFromArray(sMatches)
    iMatchCount = UBound(sMatches)
    
    For i = 0 To iMatchCount
        If (LenB(sMatches(i))) Then
            cMatchStatistic.Concat sMatches(i) & APP_HITPOINTS_DELIMITER & ArrayCountIf(sMatchList, sMatches(i)) & vbCrLf
        End If
    Next i
    
    GenerateMatchStatistics = cMatchStatistic.Value
End Function

Public Sub RemoveDuplicatesFromArray(ByRef sArray() As String)
    Dim lLowBound As Long
    Dim lUpBound As Long
    Dim sTempArray() As String
    Dim lCurrent As Long
    Dim i As Long
    Dim j As Long
    
    lUpBound = UBound(sArray)
    
    If (lUpBound > 0) Then
        lLowBound = LBound(sArray)
        
        ReDim sTempArray(lLowBound To lUpBound)
        
        lCurrent = lLowBound
        sTempArray(lCurrent) = sArray(lLowBound)
        
        For i = lLowBound + 1 To lUpBound
            For j = lLowBound To lCurrent
                If LenB(sTempArray(j)) = LenB(sArray(i)) Then
                    If InStrB(1, sArray(i), sTempArray(j), vbBinaryCompare) = 1 Then
                        Exit For
                    End If
                End If
            Next j
            
            If j > lCurrent Then
                lCurrent = j
                sTempArray(lCurrent) = sArray(i)
            End If
        Next i
        
        ReDim Preserve sTempArray(lLowBound To lCurrent)
        sArray = sTempArray
    End If
End Sub

Public Function ArrayCountIf(ByRef sInput As String, ByRef sSearch As String) As Integer
    Dim sArray() As String
    Dim iArrayCount As Integer
    Dim i As Integer
    Dim iSum As Integer
    
    sArray = Split(sInput, ";", , vbBinaryCompare)
    iArrayCount = UBound(sArray)
    
    For i = 0 To iArrayCount
        If (sArray(i) = sSearch) Then
            iSum = iSum + 1
        End If
    Next i
    
    ArrayCountIf = iSum
End Function

Public Function GenerateHttpdIcon(ByVal sImplementation As String) As Integer
    sImplementation = LCase(sImplementation)

    If (InStrB(1, sImplementation, "aol", vbBinaryCompare)) Then
        GenerateHttpdIcon = 1
    ElseIf (InStrB(1, sImplementation, "abyss", vbBinaryCompare)) Then
        GenerateHttpdIcon = 1
    End If
End Function

Public Sub AnnounceFingerprintMatches(ByRef sFullMatchList As String)
    Dim sResultList As String
    Dim sResultArray() As String
    Dim i As Integer
    Dim iResultCount As Integer
    Dim lList As ListItem
    Dim sEntry() As String
    Dim iBestHitter As Integer
    Dim dBestMatch As Double
    
    Call ChangeStatusBar("Preparing Results...")

    sResultList = GenerateMatchStatistics(sFullMatchList)
    sResultArray = Split(sResultList, vbCrLf, , vbBinaryCompare)
    iResultCount = UBound(sResultArray)
    
    For i = 0 To iResultCount
        If (LenB(sResultArray(i))) Then
            sEntry = Split(sResultArray(i), APP_HITPOINTS_DELIMITER, , vbBinaryCompare)
            
            If (scan_besthitcount < sEntry(1)) Then
                scan_besthitname = sEntry(0)
                scan_besthitcount = sEntry(1)
            End If
        End If
    Next i
    If (scan_besthitcount < app_hitpoints_minimum) Then
        iBestHitter = app_hitpoints_minimum
    ElseIf (scan_besthitcount > app_hitpoints_maximum) Then
        iBestHitter = app_hitpoints_maximum
    Else
        iBestHitter = scan_besthitcount
    End If
    
    frmMain.lsvResults.Visible = False
    frmMain.lsvResults.ListItems.Clear
    For i = 0 To iResultCount
        If (LenB(sResultArray(i))) Then
            sEntry = Split(sResultArray(i), APP_HITPOINTS_DELIMITER, , vbBinaryCompare)
            
            dBestMatch = (100 / iBestHitter * sEntry(1))
            If (dBestMatch > 100) Then
                dBestMatch = 100
            End If
            
            Set lList = frmMain.lsvResults.ListItems.Add(, , vbNullString, , GenerateHttpdIcon(sEntry(0)))
                lList.SubItems(1) = sEntry(0)
                lList.SubItems(2) = sEntry(1)
                lList.SubItems(3) = dBestMatch
        End If
    Next i
    frmMain.lsvResults.Visible = True
    
    Call ListViewSort(frmMain.lsvNegotiation, frmMain.lsvNegotiation.ColumnHeaders(1), 0)
    Call ListViewSort(frmMain.lsvResults, frmMain.lsvResults.ColumnHeaders(3), 1)
    Call ChangeStatusBarReady
End Sub

Public Function IdentifyGlobalFingerprint(ByRef sFingerprintDirectory As String) As String
    Dim cFullMatchList As Concat
    
    Set cFullMatchList = New Concat
    
    cFullMatchList.Concat FindMatchInDatabase(sFingerprintDirectory & app_file_will, fingerprint_will)
    cFullMatchList.Concat FindMatchInDatabase(sFingerprintDirectory & app_file_wont, fingerprint_wont)
    cFullMatchList.Concat FindMatchInDatabase(sFingerprintDirectory & app_file_do, fingerprint_do)
    cFullMatchList.Concat FindMatchInDatabase(sFingerprintDirectory & app_file_dont, fingerprint_dont)
    
    IdentifyGlobalFingerprint = cFullMatchList.Value
End Function

Public Sub ServerAnalysis()
    Dim lWaitUntil As Long
    
    Call DisableElements
    Call ChangeStatusBar("Starting Analysis...")

    scan_time = Time
    scan_date = Date
    scan_besthitcount = 0
    scan_besthitname = vbNullString

    scan_targethost = frmMain.txtTargetHost.Text
    scan_targetport = frmMain.cboTargetPort.Text
    frmMain.Caption = APP_NAME & " - " & scan_targethost & ":" & scan_targetport
    frmMain.fraTarget.Caption = "Target (unknown)"
    
    Call WriteConfigurationToFile(app_configuration_filename)
    DoEvents

    frmMain.wskConnection.Close
    
    Call ChangeStatusBar("Open connection to " & scan_targethost & ":" & scan_targetport & "...")
    frmMain.timTimeout.Enabled = True
    frmMain.wskConnection.Connect scan_targethost, scan_targetport
End Sub

Public Sub AnalyzeFingerprintsAndShowResult()
    Dim sFullIdentifyList As String

    sFullIdentifyList = IdentifyGlobalFingerprint(app_dir_databases)
    
    Call FillResponses
    Call AnnounceFingerprintMatches(sFullIdentifyList)
    frmMain.fraTarget.Caption = "Target (" & scan_besthitname & ")"
    frmMain.fraResults.Caption = "Matchlist (" & frmMain.lsvResults.ListItems.Count & " implementations)"
    frmMain.mnuFileSaveAsScanItem.Enabled = True
    frmMain.mnuFingerprintingSaveFingerprintItem.Enabled = True
    frmMain.mnuFingerprintingReanalyzeItem.Enabled = True
    frmMain.mnuReportingGenerateReportItem.Enabled = True
End Sub

Public Sub FillResponses()
    Dim iIndex As Integer
    
    iIndex = frmMain.tbsViews.SelectedItem.Index

    If (iIndex = 1) Then
        frmMain.lsvNegotiation.Visible = True
        frmMain.txtResponses.Visible = False
    ElseIf (iIndex = 2) Then
        frmMain.txtResponses.Visible = True
        frmMain.lsvNegotiation.Visible = False
        frmMain.txtResponses.Text = scan_response
    ElseIf (iIndex = 3) Then
        frmMain.txtResponses.Visible = True
        frmMain.lsvNegotiation.Visible = False
        frmMain.txtResponses.Text = fingerprint_full
    ElseIf (iIndex = 4) Then
        frmMain.txtResponses.Visible = True
        frmMain.lsvNegotiation.Visible = False
        frmMain.txtResponses.Text = fingerprint_will
    ElseIf (iIndex = 5) Then
        frmMain.txtResponses.Visible = True
        frmMain.lsvNegotiation.Visible = False
        frmMain.txtResponses.Text = fingerprint_wont
    ElseIf (iIndex = 6) Then
        frmMain.txtResponses.Visible = True
        frmMain.lsvNegotiation.Visible = False
        frmMain.txtResponses.Text = fingerprint_do
    ElseIf (iIndex = 7) Then
        frmMain.txtResponses.Visible = True
        frmMain.lsvNegotiation.Visible = False
        frmMain.txtResponses.Text = fingerprint_dont
    End If
End Sub

Public Sub ResetAll()
    frmMain.Caption = APP_NAME
    
    scan_besthitcount = 0
    scan_besthitname = vbNullString
    
    scan_time = vbNullString
    scan_date = vbNullString
    scan_targethost = "127.0.0.1"
    scan_targetport = 23
    
    fingerprint_full = vbNullString
    fingerprint_will = vbNullString
    fingerprint_wont = vbNullString
    fingerprint_do = vbNullString
    fingerprint_dont = vbNullString
        
    frmMain.fraTarget.Caption = "Target"
    
    frmMain.txtTargetHost = scan_targethost
    frmMain.cboTargetPort = scan_targetport
    
    frmMain.lsvNegotiation.ListItems.Clear
    frmMain.txtResponses.Text = vbNullString
    frmMain.txtResponses.ToolTipText = vbNullString
    frmMain.lsvResults.ListItems.Clear
    
    frmMain.mnuFileSaveAsScanItem.Enabled = False
    frmMain.mnuFingerprintingReanalyzeItem.Enabled = False
    frmMain.mnuFingerprintingSaveFingerprintItem.Enabled = False
    frmMain.mnuReportingGenerateReportItem.Enabled = False
End Sub

Public Sub DisableElements()
    frmMain.lsvNegotiation.ListItems.Clear
    frmMain.txtResponses.Text = vbNullString
    frmMain.lsvResults.ListItems.Clear
    frmMain.cmdAnalyze.Enabled = False
    frmMain.mnuFileNewItem.Enabled = False
    frmMain.mnuFileOpenScanlistItem.Enabled = False
    frmMain.mnuFileOpenScanItem.Enabled = False
    frmMain.mnuFileSaveAsScanItem.Enabled = False
    frmMain.mnuConfigurationEditItem.Enabled = False
    frmMain.mnuFingerprintingAnalyzeItem.Enabled = False
    frmMain.mnuFingerprintingReanalyzeItem.Enabled = False
    frmMain.mnuFingerprintingSaveFingerprintItem.Enabled = False
    frmMain.txtTargetHost.Enabled = False
    frmMain.cboTargetPort.Enabled = False
    Screen.MousePointer = vbArrowHourglass
End Sub

Public Sub EnableElements()
    frmMain.cmdAnalyze.Enabled = True
    frmMain.mnuFileNewItem.Enabled = True
    frmMain.mnuFileOpenScanlistItem.Enabled = True
    frmMain.mnuFileOpenScanItem.Enabled = True
    frmMain.mnuFileSaveAsScanItem.Enabled = True
    frmMain.mnuConfigurationEditItem.Enabled = True
    frmMain.mnuFingerprintingAnalyzeItem.Enabled = True
    frmMain.mnuFingerprintingReanalyzeItem.Enabled = True
    frmMain.mnuFingerprintingSaveFingerprintItem.Enabled = True
    frmMain.txtTargetHost.Enabled = True
    frmMain.cboTargetPort.Enabled = True
    Screen.MousePointer = vbNormal
End Sub

